/*
** Module   : ToggleBoxWidget.java
** Abstract : Toggle-box widget.
**
** Copyright (c) 2010-2011, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- ----------------Description-------------------------------
** 001 SVL 20101004 Created initial version.
** 002 SIY 20110112 Suppressed warning.
** 003 SIY 20111101 Updated imports.
** 004 CA  20130930 Added LegacyResource annotation, to determine resource type.
*/

package com.goldencode.p2j.ui;

import com.goldencode.p2j.util.*;

/**
 * Toggle-box widget.
 */
@LegacyResource(resource = LegacyResource.TOGGLE_BOX)
public class ToggleBoxWidget
extends ControlEntity
{
   /** Toggle-box-specific configuration. */
   @SuppressWarnings("unused")
   private ToggleBoxConfig tbc;

   /**
    * Default constructor.
    */
   public ToggleBoxWidget()
   {
      super(new ToggleBoxConfig(ComponentConfig.TOGGLE_BOX));
      this.tbc = (ToggleBoxConfig) config;
   }
}
