/*
** Module   : SOAPHeaderImpl.java
** Abstract : Implementation for the SOAP-HEADER resource.
**
** Copyright (c) 2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** -#- -I- --Date-- --------------------------------Description-----------------------------------
** 001 CA  20130216 Created initial version.
** 002 CA  20130221 Added ADM-DATA, UNIQUE-ID support. Fixed resource type.
** 003 OM  20130304 Refactored isValid and isUnknown of WrappedResource to valid and unknown.
** 004 CA  20130603 resourceDelete must return a boolean value.
** 005 CA  20130927 Removed setResourceType, as the type is determined from LegacyResource 
**                  annotation.
*/

package com.goldencode.p2j.util;

/**
 * A class for implementing the SOAP-HEADER method and attributes.
 * TODO: add support only for NAME and PRIVATE-DATA attributes (without PREV-/NEXT-SIBLING)
 */
public class SOAPHeaderImpl
extends HandleChain
implements SOAPHeader,
           CommonHandleChain
{
   /**
    * Returns the number of SOAP-HEADER-ENTRYREF object entries attached to the SOAP-HEADER 
    * object.
    * 
    * @return   See above.
    */
   public integer getNumHeaderEntries()
   {
      // TODO: implement this
      return new integer();
   }

   /**
    * Creates a new entry in a SOAP-header object's list of entries and associates the new entry
    * with the given SOAP-HEADER-ENTRY-REF object.
    * 
    * @param    entryRef
    *           The handle where the resource will be set.

    * @return   <code>true</code> if the operation was possible.
    */
   public logical addHeaderEntry(handle entryRef)
   {
      // TODO: implement this
      return new logical();
   }

   /**
    * Get the header entry at the given index and assign it to the given handle.
    * <p>
    * This method returns a logical even though the Progress 4GL documentation explicitly states 
    * otherwise. Actual working code has proven that the original documentation is incorrect. 
    * This implementation matches the actual runtime behavior of the 4GL.
    * 
    * @param    target
    *           The handle where the SOAP-HEADER-ENTRY instance will be saved.
    * @param    idx
    *           The index of the SOAP-HEADER-ENTRY instance to retrieve. 4GL allows only integer
    *           and int64 values to be passed to this parameter.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical getHeaderEntry(handle target, long idx)
   {
      return getHeaderEntry(target, new int64(idx));
   }

   /**
    * Get the header entry at the given index and assign it to the given handle.
    * <p>
    * This method returns a logical even though the Progress 4GL documentation explicitly states 
    * otherwise. Actual working code has proven that the original documentation is incorrect. 
    * This implementation matches the actual runtime behavior of the 4GL.
    * 
    * @param    target
    *           The handle where the SOAP-HEADER-ENTRY instance will be saved.
    * @param    idx
    *           The index of the SOAP-HEADER-ENTRY instance to retrieve. 4GL allows only integer
    *           and int64 values to be passed to this parameter.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical getHeaderEntry(handle target, integer idx)
   {
      return getHeaderEntry(target, new int64(idx));
   }

   /**
    * Get the header entry at the given index and assign it to the given handle.
    * <p>
    * This method returns a logical even though the Progress 4GL documentation explicitly states 
    * otherwise. Actual working code has proven that the original documentation is incorrect. 
    * This implementation matches the actual runtime behavior of the 4GL.
    * 
    * @param    target
    *           The handle where the SOAP-HEADER-ENTRY instance will be saved.
    * @param    idx
    *           The index of the SOAP-HEADER-ENTRY instance to retrieve. 4GL allows only integer
    *           and int64 values to be passed to this parameter.
    * 
    * @return   <code>true</code> if the operation was possible.
    */
   public logical getHeaderEntry(handle target, int64 idx)
   {
      // TODO: implement this
      return new logical();
   }
   
   /**
    * Reports if this object is valid for use.  
    *
    * @return   <code>true</code> if we are valid (can be used).
    */
   public boolean valid()
   {
      // TODO: implement this
      return true;
   }

   /**
    * Get the value of the ADM-DATA attribute.
    * 
    * @return   See above.
    */
   @Override
   public character getADMData()
   {
      // TODO Auto-generated method stub
      return null;
   }

   /**
    * Set the value of the ADM-DATA attribute.
    * 
    * @param    value
    *           The new value.
    */
   @Override
   public void setADMData(String value)
   {
      // TODO Auto-generated method stub
      
   }

   /**
    * Set the value of the ADM-DATA attribute.
    * 
    * @param    value
    *           The new value.
    */
   @Override
   public void setADMData(character value)
   {
      // TODO Auto-generated method stub
   }

   /**
    * Gets the the unique ID number associated to this object by the underlying system. Not the 
    * same as the handle value itself.
    * 
    * @return   The integer number of the children.
    */
   @Override
   public integer getUniqueID()
   {
      // TODO Auto-generated method stub
      return null;
   }

   /**
    * Delete the resource.
    * 
    * @return   <code>true</code> if the resource was deleted.
    */
   @Override
   protected boolean resourceDelete()
   {
      // TODO Auto-generated method stub
      return false;
   }
}
